#
# agreement_text.py: text mode License Agreement window
#
# Copyright 2004 Miracle Linux Corp.
#
# This software may be freely redistributed under the terms of the GNU
# library public license.
#
# You should have received a copy of the GNU Library Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

import time
from snack import *
from constants_text import *
from rhpl.translate import _
from rhpl.log import *
from constants import *
import os

class AgreementWindow:
    def __call__(self, screen, intf, id, dispatch):
        langName = id.instLanguage.getLangNick(id.instLanguage.getCurrent())
        lang = string.split(langName, ".")
        lang = string.split(lang[0], "_")
        if (lang[0] == 'zh' or lang[0] == 'pt'):
            lang[0] = lang[0] + '_' + lang[1]
        if lang[0] == 'en':
            lang[0] = None

        suffixList = []
        if lang[0]:
            suffixList.append(".%s" % (lang[0],))
	else:
            suffixList.append("")
        text = ''
	flag = None
        sourcepath = dispatch.method.getSourcePath()
	if sourcepath == None:
	    try:
        	dispatch.method.mountMedia(1)
	    	sourcepath = dispatch.method.getSourcePath()
	    	flag = 'mount'
	    except:
		pass
                
        for suffix in suffixList:
            fn = "%s/Documents/EULA%s" % (sourcepath, suffix)
            if os.access(fn, os.R_OK):
                file = open(fn, "r")
                text = file.read()
                file.close()
                break
            else:
                import urllib2
		try:
                    url = dispatch.method.getBaseUrl()
		except:
		    log("Can not find agreement!")
		    break

                fn = "%s/Documents/EULA%s" % (url, suffix)
                tries = 0
		file = None
                while tries < 5:
                    try:
                        file = urllib2.urlopen(fn)
                    except urllib2.HTTPError, e:
                        log("HTTPError: %s occurred getting %s", fn, e)
                    except urllib2.URLError, e:
                        log("URLError: %s occurred getting %s", fn, e)
                    except IOError, (errnum, msg):
                        log("IOError %s occurred getting %s: %s", fn,
                            errnum, str(msg))
                    except OSError, (errnum, msg):
                        log("OSError %s occurred getting %s: %s", fn,
                            errnum, str(msg))
                    else:
                        break

                    time.sleep(5)
                    tries = tries + 1

		if file != None:
                    text = file.read()
                    file.close()
                break

        if not text:
            text = _("Now preparing.")
        rc = ButtonChoiceWindow(screen, _("License Agreement"), text,
                               buttons = [TEXT_ACCEPT_BUTTON, TEXT_BACK_BUTTON],
                               width = 70)

	if flag == 'mount':
	    try:
	    	dispatch.method.umountMedia()
	    except:
		pass

	if rc == TEXT_BACK_CHECK:
	    return INSTALL_BACK

        return INSTALL_OK

